2012 Sep09: release 0.26.0

- The htmlsection predicate that cuts it out in each section of html is added. 
- The htmlCommenttags predicate that deletes the comment in html is added. 
- Correction used in state of nest of erasetags predicate
- The example of the compiler of the PL/0 program language is added. 
  The exercise of the function type and the closure is contained. 
- The exercise to use it with hadoop is added. 

The following bugs were corrected. 

- It compiled with gcc-4.5.3. 
- Improvement of gc (garbage collector)
- The bug to which SIGSEGV occurs in iconv is corrected. 
- The output of printlist is corrected. 
- The exercise of the ODE predicate is corrected. 


2012 Feb15: release 0.25.0

- Addition of ODE predicate that outputs solution of 
  a differential equation.
- Addition of integral predicate integrated by ODE predicate.
- Addition of ODEdiff predicate differentiated by ODE predicate.
- Addition of ODEprint and ODEprintf that outputs it 
  by ODE predicate.
- Addition of ODEcmd that calls command list by ODE predicate.
- The exercise of the differential equation is added. 
- The htmlsplit predicate that divides the html file is added. 
- The htmlleft predicate that takes out a left part of 
  the html file is added. 
- The htmlright predicate that takes out the right part of 
  the html file is added. 
- The function to convert the blank of UTF8 at the blank 
  of ASCII is added by the htmldecode predicate. 
- Correction of inheritance of object.

The following bugs were corrected. 

- The error of the interpretation of the syntax of a negative 
  unary operator ahead of parentheses is corrected. 
- The bug from which the character string is converted into 
  the small letter by the erasetag predicate is corrected. 
- The bug in the scope of getVar and the getArray predicate 
  to the object is corrected. 
- GetVar and getArray are added to the reserved word. 
- An unnecessary string.h header is deleted. 
- The bug of the recursive processing is corrected by 
  exercise Closure Basic. 


2011 Sept19: release 0.24.0

- Improvement of http client
- The RSS reader is added as an exercise of the http client. 
- Addition of strcode predicate that judges character-code
- Addition of automatic judgment function of character-code of 
  iconv predicate
- The character string list is enabled to be specified by 
  the argument of the following predicates. 
   split, splitline, trim, lefttrim, righttrim, chop, and chomp,
   urlencode, urldecode, htmlencode, htmldecode, concat, concatcode,
   regex, gsub, sub, grep, grepi, grepv, 
- Addition of flatten predicate that makes list smooth
- The use of the regex library is enabled with mingw. 
- Regex that uses the regular expression, 
  gsub, sub, grep, grepi, and the grepv predicate are added. 
- Configure and Makefile are shared with linux, cygwin, mingw, 
  and opensolaris. 
- Permutation and the combination predicate are improved. 
- The fileget predicate that reads the variable the content of 
  the file is added. 
- The splittags predicate that delimits html with tag and makes 
  to the list is added. 
- The CHECKSRC predicate that detects an undefined predicate 
  and the misspelling predicate on the source is added. 
- Addition of screen clear function with Windows

The following bugs were corrected. 

- The judgment mistake of compare, comparef, and comparec is corrected. 
- The SIGSEGV generation by htmltags is corrected. 


2011 Aug14: release 0.23.0

- The http client function is added. 
  (httppost of httphead of httpget of GET method and HEAD method 
   and POST method)
- The getenv predicate to acquire the environment variable is added. 
- Addition of htmlencode and htmldecode predicate to do encode and 
  decode by POST method
- Addition of urlencode and urldecode predicate that does encode 
  and decode as argument of url
- The htmltags predicate that pulls out the range of the tag that 
  html specified is added. 
- The erasetags predicate that erases the range of the tag that 
  html specified is added. 
- The erasealltags predicate that erases all the tag of html is added. 
- The pulloutstr predicate that pulls out the character string 
  within the specified range is added. 
- The erasestr predicate that deletes the character string within 
  the specified range is added. 
- The program exercise of the http client function is added 
  (nationwide electric power situation, economic indicator, and news headline). 
- Addition of iconv predicate that converts character string code
- Performance gain by improvement of unification (unification) processing
- Improvement of GC (garbage collector)

The following bugs were corrected. 

- The judgment mistake of compare, comparef, and the comparec 
  predicate is corrected. 
- The processing mistake of the argument of the sort predicate 
  is corrected. 

2011 Jun26: release 0.22.0

- Program example: Addition of Japanese program language "Murasaki"
- Program example: Improvement of Descartes lisp
- Program example: Improvement of Closure Basic
- Reerse and the member predicate are added to the sys module. 
- Addition of link module library
- Addition of mkpredlist predicate
- The specification of two or more predicates was enabled the argument 
  of the timeout predicate. 
- Addition of PrintResultOn that controls result display and 
  PrintResultOff predicate
- Review of debugging trace information

 The following bugs are corrected.

- Initialization of Module variable
- The remark sign was not able to be used by parsing. 
- The flash of the input was stopped by the flush predicate. 

2011 Jan11: release 0.21.1

- Bug correction of example of Closure Basic

2011 Jan8: release 0.21.0

- The performance of the garbage collection is improved to twice. 
- The quantity consumed of the memory is improved to 1/10. 
- Performance improvement of list processing
- A high-speed append predicate is added to the sys module. 
- The flush predicate is added to the sys module. 
- The checkObj predicate that judges whether it is an object is added. 
- Random numbers predicate random improvement
- Improvement of conversation character of exercise
- It corresponds to OpenSolaris the source. 
- The compiler of Closure Basic is added as an exercise. 

 The following bugs are corrected.

- The length judgment of () of the length predicate is corrected to 0. 
- Abnormality when converting it from the character string into 
  the figure is corrected. 
- Correction of error message of openr and openwr
- Correction of predicate that token of one character reads

2010 Aug22: release 0.20.0

- Update of conversation character of exercise 
- Descartes Lisp of exercise it update
- Addition of catch predicate and throw predicate that interrupts 
  processing on the way
- Addition of EqOR predicate that examines agreement with two or 
  more values
- Addition of switch predicate that diverges to processing that 
  corresponds to corresponding value
- Addition of nth predicate and setnth predicate that processes 
  nth of list
- Addition of trace information on object
- Addition of padding predicate to list specified length

 The following bugs are corrected.

- Processing is abnormal of the file pointer when the file is input. 
- The mistake of the call of the method of the object is corrected. 
- The method of the processing at the blank of the EOF predicate is 
  changed. 
- Separate treatment of old and new object in clone processing of object


2010 Apr25: release 0.19.0

- Making of conversation character of exercise 
   (Eliza, cat ear, and tsundere)
- Addition of catch predicate and throw predicate
- The mechanism to make the stand-alone application is added. 

 The following bugs are corrected.

- Correspondence when argument is Nil in generator library

2010 Apr11: release 0.18.0

- Descartes Lisp/λ exercise is greatly improved. 
- Descartes language IDE addition for Windows
- Enhancing of list display

 The following bugs are corrected.

- The error of file open predicate is corrected. 
- Correction of changing line processing
- Correction of range of UTF-8 character
- Correction of error judgment of line predicate


2010 Feb7: release 0.17.0

- Descartes Lisp/λ is added as an exercise. 
- -t and --trace options for debugging trace,
- Optional -r that doesn't display the execution result is added. 
- The variable was able to be specified for the object name. 
- The seq predicate is added to the sys module. 
- The variable that collected the results in the loop{} is
  able to be specified for the loop{}. 
- Parsing predicate SNUM and SFNUM of the integer and the floating 
  point number with the sign are added. 

 The following bugs are corrected.

- Addition of processing when there is no ncurses.h in cygwin environment.
- The method of the object cannot be dynamically deleted. 
- Lack of include of string.h header
- When the getline predicate was executed again, the variable of 
  the argument was not cleared. 
- When a long list is displayed, SIGSEGV occurs. 
- The file pointer doesn't return to the re-execution of the NULLLINE 
  predicate. 

2010 Jan 10: release 0.16.0

- Addition of generator module
- Addition of check function of reserved word

2009 Nov 01: release 0.15.0

- Addition of break predicate
- Change in operation of delVar predicate to undecided variable
- Addition of manual of list module
- Addition of puzzle exercise

 The following bugs are corrected.

- Correction of re-execution processing of CR predicate
- Correction of SIGSEGV generated at syntax error


2009 Sep 21: release 0.14.0

- Addition of trace information (display of undefined predicate)
- Addition of Pretty print function of multi core function
- Addition of INDENT and NEXTINDENT predicate
- Addition of procession matrix module

 The following bugs are corrected.

- Print display of NIL
- Abnormality of processing of CR predicate at blank

2009 Aug 2: release 0.13.0

- Enhancing of string manipulation
  - Addition of trim, lefttrim, righttrim predicate.
  - Addition of chop, chomp predicate.
  - The treatment of the blank of the multi byte is enhanced. 
  - Addition of strreverse
  - Addition of strrepeat, strshiftleft, strshiftright predicate.
  - Addition of strsort, strsortreverse predicate.
  - Addition of strlen, strbyte predicate.
  - Addition of strfry predicate.
  - Addition of strdelcntl predicate.
  - Addition of NEXTCHAR, NEXTSTR, NEXTSYNTAX predicate.
  - Addition of NOTNEXTSTR, NOTNEXTSYNTAX predicate.
- Addition of is, eq, noteq predicate.
- So as not to display anything from (), the display of Nil was changed. 
- Trace facility of multi core function.

 The following bugs are corrected.

- Renewal of input-output buffer of multi core execution
- Initialization of random numbers in multi core process
- The processing when the argument of foreach, firstforeach, eachproc, 
  and firsteachproc is Nil is corrected. 
- Error of split predicate
- Cancellation of warning message that had come out with gcc 4.3.3 .
- Processing of multi byte character with substr, leftstr, rightstr, and char

2009 July 7: release 0.12.0

- For multi core of cygwin edition
- For multi core of mingw version.
 (It doesn't operate in the multi core and simulate it in a single 
  core in the mingw version. )
- Addition of firstfor and firstforeach predicate.
- Control of excessive process generation with multi core function.

 The following bugs are corrected.

- SIGSEGV in garbage collection.
- Interprocess communication error for multi core.
- Communication fault of floating point number with multi core correspondence.

2009 June 21: release 0.11.0

- Addition of predicate for multi core.
- Enhancing of for and foreach predicate.
- Addition of nop predicate.
- Addition of findlist predicate.
- Addition of NULLLINE predicate.
- Addition of isObj predicate.
- Addition of cloneObj predicate.
- Addition of test set for object.
- Update of internal processing of object processing.

 The following bugs are corrected.

- It terminates abnormally because of the evaluation of the argument 
  of the built-in predicate. 
- Review of permission of file for make.
- Abnormality of processing of argument of delArray and delVar predicate.
- The processing when the comment became EOF on the way is corrected. 
- It is corrected to become SIGSEGV because of the calculation of the eigenvalue. 

2009 Apr 29: release 0.10.0

- The self object is added. 
- Processing when cntl-c was pushed by interactive processing is added. 
- Sort, sortascend, and the sortdescend predicate are added to the sys module. 
- IsRegistered and the isUnregistered predicate are added to the sys module. 

 The following bugs are corrected.

- The evaluation of the argument of the built-in module not corrected 
  has been enhanced. 
- Deletion of unnecessary tmpfile.
- Correction of mul predicate of matrix module.
- Abnormal operation of the mechanism of object-oriented was corrected. 
- It was corrected not to be able to output Nil with printlist and printlistnl. 
- The return value of the character string transform function was corrected. 
- Abnormal operation when inputting it to the getline predicate with 
  the redirection is corrected. 

2009 Apr08: release 0.9.0

- The addition of the module of matrix.
- The addition of the module of list.
- The addition of the module of curses.
- The exercise of tinyruby is updated.
  Error handling of Tiny Ruby is corrected.
- Addition of predicate of conversational processing function
- Deletion of unnecessary trace information
- GC starting frequency is raised.
- An improvement of the reading speed of the library module in Windows
  Change of open processing of temp file in mingw
- SetVar is changed into AddVar.

 The following bugs are corrected.

- The operation error message of a variable without a value is improved.
- Reexamination of the error judging conditions of an isX predicate
- Reexamination of the error message of a regex predicate
- The error of an instr predicate name is corrected.
- The error of a reading result judging of EOF of getc
- Change of error handling of a delArray predicate
- It is prevention of read error SEGV of the multi-byte character
- Correction of error handling of regex
- Buffer overflow of a token is prevented.
- Initialization of the non-set up variable of syntax-analysis processing.

2009 Mar15: release 0.8.0

- The addition of x predicate which is a special predicate.
- The addition of a curses function.
- Expansion of the evaluation range of the argument of a predicate function.
- Arrangement of trace information.
- The addition of a LIST operation predicate.
- list, the screen display function of a pwd predicate.
- The addition of a character string operation predicate (leftstr, rightstr, 
 substr, insert)
- The addition of a compiler support function.
- Error-checking strengthening when an argument is unusual.
- An addition and change of icon.
- The addition of the new example of a program, and document creation.
- Creation of a regression test set.
- Deletion and arrangement of an unnecessary predicate.
- Strengthening of the message display at the time of an error.

- The following bugs are corrected.
- SIGSEGV occured in RANGE predicate.
- Error handling of the predicate which open a file
- They are abnormalities as a result of car and a cdr predicate.
- SIGSEGV occured in syntax predicate.
- The judgment error of an isPred predicate.
- They are abnormalities as a result of the comparison predicate of a number.
- They are abnormalities as a result of a gsub predicate.

2009 Feb24: release 0.7.0

- Support of a complex number, and the addition of letc and a rpnc predicate.
- Complex number support of trigonometric functions and a logarithmic function.
- The addition of real of complex number operation, image, arg, norm, conj, 
  and a polar predicate.
- The addition of PI and e of a mathematics constant.
- The addition of sum which calculates a sum total value, and a sumf predicate.
- The addition of avg which calculates average value, and an avgf predicate.
- The addition of isNan of a floating point number, inInf, and a Finite predicate.
- The addition of ext2, ext10 predicate.
- It corrects so that it can process, even if the 2nd byte and the ASCII 
  code of SJIS overlap in a pattern match.
- SKIP of syntax analysis, the addition of a SKIPCR predicate.
- The addition of SKIP and the SKIPCR predicate of syntax analysis.
- The addition of the suffix predicate which changes the suffix of a file name.
- The addition of the nth predicate which takes out List n-th element.
- The addition of the predicate leftstr, rightstr, substr, insertstr of 
  character string operation

2009 Feb15: release 0.6.0

- Reexamination of an object-oriented inherit mechanism.
- Object-oriented self, the addition of a super predicate.
- Reexamination of an objDelArray predicate.
- The addition of a printf predicate, a format predicate, 
  and an escape sequence predicate.
- Add printlist and printlistnl of a LIST display function.
- The addition of the uname predicate which displays system information.
- The function which takes out the file and directory of a path. 
  The addition of basename and a dirname predicate.
- The addition of the clear predicate which clears a screen.
- The addition of sleep and a usleep predicate.
- The addition of a pause predicate.
- Renewal of error processing of regex, gsub, and sub predicate.
- The addition of an example exercise.

2009 Feb8: release 0.5.0

- The addition of the dynamic object operation method
- Selection of the classification of a character code is possible 
  as a command line option.
- time predicate display is updated
- pow predicate is added
- The addition of detailed HELP
- Change of interaction processing
- Correction of a display of an object
- Change of the trace information on a func function predicate
- Renewal of the method of preservation of a save predicate

2009 Feb1: release 0.4.0

- The operation accuracy of a floating point From double, to long double Extended 
- * Change of the display method of additional 
- program module of additional 
- concat of additional 
- syntax predicate of the trace information on the correction
- * wild card predicate of a wild card predicate, and a concatcode predicate 
- execution time Addition of additional 
- toupper of the time predicate to measure, additional 
- floor of a tolower predicate, log10, max, min, maxf, and a minf predicate 
- Reexamination of the compile method of improvement
- Makefile of interactive processing


2009 Jan25: release 0.3.0

- Incorporate an EBNF syntax-analysis predicate from a sys module, 
  and it is the addition of additional 
- save predicate of additional 
- * wild card predicate of a change-syntax predicate to a predicate. 
- The addition of additional 
- data predicate of a gettime predicate
- Formation of a pretty print of a result display of an execution result 
- Renewal of a document. 
- English translation of a document. 
- Renewal of an example program. 
- Incorporate with a sys module and separate the sauce of a predicate.


2009 Jan17: release 0.2.0

- Integral accuracy was extended to 64 bits from 32 bits. 
- The addition of an edit predicate. 
- Change of the loop count of a for predicate. 
- It is a predicate which matches the head of a line <^>; Additional : 
- The predicate which matches the last of a line is added. <$>;
- cd, dir, and ls predicate were added. 
- The random predicate in the Windows version  having supported . 
- Renewal of a document. 
- English translation of a document. 
- Renewal of an example program. 
- Change of the compile option of Makefile. 
- The addition of config.h.


2009 Jan12: new release 0.1.0

